"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GKErrorWrap = void 0;

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

if (!JSON.stringifyline) {
  JSON.stringifyline = function (Obj) {
    return JSON.stringify(Obj, null, 2);
  };
}

var errCodes = {};
/*
 错误信息生成器，高阶函数
 */

var GKErrorWrap = function GKErrorWrap(errCode, errMessage) {
  if (errCodes[errCode]) throw new Error("\u9519\u8BEF\u7801\u88AB\u91CD\u590D\u5B9A\u4E49(".concat(errCode, ",").concat(errCodes[errCode], ")"));
  errCodes[errCode] = errMessage;
  return function (more) {
    var moreStr = '';

    if (more) {
      moreStr = typeof more === "string" ? more : JSON.stringifyline(_objectSpread2({}, more));
    }

    var ret = new Error();
    ret._gankao = 1;
    ret.code = errCode;

    if (!moreStr) {
      ret.message = errMessage;
    } else if (!errMessage) {
      ret.message = moreStr;
    } else {
      ret.message = "".concat(errMessage, " (").concat(moreStr, ")");
    }

    ret.more = moreStr;
    return ret;
  };
};

exports.GKErrorWrap = GKErrorWrap;