"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BindGkInfoAndInjectToReqMiddleWare = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * 等待指定毫秒时间后再继续执行
 * @param ms
 * @returns {Promise}
 */
var sleep = function sleep(ms) {
  return new _bluebird["default"](function (resolve, reject) {
    setTimeout(function (_) {
      return resolve(ms);
    }, ms);
  });
};

var getCookieDomain2 = function getCookieDomain2(reqOrHostName) {
  var hostname = '';

  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object") {
    hostname = window.location.hostname;
  } else {
    if (!reqOrHostName) {
      throw new Error('_getCookieDomain2函数在服务器端运行时，需传入req或hostname值的参数');
    }

    hostname = _typeof(reqOrHostName) === "object" ? reqOrHostName.headers["host"] : reqOrHostName;
  }

  var _hostname$split$0$spl = hostname.split(":")[0].split(".").reverse(),
      _hostname$split$0$spl2 = _slicedToArray(_hostname$split$0$spl, 2),
      domainType = _hostname$split$0$spl2[0],
      _hostname$split$0$spl3 = _hostname$split$0$spl2[1],
      domain = _hostname$split$0$spl3 === void 0 ? '' : _hostname$split$0$spl3;

  return "".concat(domain, ".").concat(domainType);
};

var _parseServiceEndPoint = null;

var getPartner =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(hostname) {
    var printLog, apiUrl, query, res2, jsonResult, err, result, _ref2, partner, failMessage;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            printLog = process.env.NODE_ENV === 'development' || ~~process.env.GK_LOG === 1;
            apiUrl = _parseServiceEndPoint + "/gkauth/parsePartner?partnerIdOrEnameOrHostName=".concat(hostname);
            query = {
              method: 'GET',
              rejectUnauthorized: false,
              headers: {
                'Accept': 'application/json, text/plain, */*',
                'Content-Type': 'application/json'
              },
              json: true
            };

            if (printLog) {
              console.log("getPartner apiUrl:", apiUrl);
            }

            _context.next = 6;
            return (0, _isomorphicFetch["default"])(apiUrl, query);

          case 6:
            res2 = _context.sent;
            _context.next = 9;
            return res2.json();

          case 9:
            jsonResult = _context.sent;
            err = jsonResult.err, result = jsonResult.result;

            if (!err) {
              _context.next = 16;
              break;
            }

            if (printLog) {
              console.error(jsonResult);
            }

            return _context.abrupt("return", {
              __partner: null,
              __partner_error: err
            });

          case 16:
            _ref2 = result || {}, partner = _ref2.partner, failMessage = _ref2.failMessage;

            if (failMessage && printLog) {
              console.error(jsonResult);
            }

            if (partner) {
              //注意，需要删除机构密钥值，这个机构密钥后续不能放在partner表里
              delete partner.encrypt;

              try {
                partner.settings = JSON.parse(partner.settings);
              } catch (e) {
                partner.settings = {
                  __message: 'parse error in api'
                };
              }

              partner.aimodel = ~~partner.orgType === 2 ? 2 : partner.aimodel;
            }

            return _context.abrupt("return", {
              __partner: partner,
              __partner_error: failMessage
            });

          case 20:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getPartner(_x) {
    return _ref.apply(this, arguments);
  };
}();

var getUserInfo =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(AuthorizationOrToken) {
    var apiUrl_user, query_user, res_user, jsonResult, err, _jsonResult$result, result, _ref4, gankaoUID, gankaoUserInfo;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            apiUrl_user = _parseServiceEndPoint + "/gkauth/parseUser?AuthorizationOrToken=".concat(AuthorizationOrToken);
            query_user = {
              method: 'GET',
              rejectUnauthorized: false,
              headers: {
                'Accept': 'application/json, text/plain, */*',
                'Content-Type': 'application/json'
              },
              json: true
            };

            if (process.env.NODE_ENV === 'development') {
              console.log("getUserInfo apiUrl:", apiUrl_user);
            }

            _context2.next = 5;
            return (0, _isomorphicFetch["default"])(apiUrl_user, query_user);

          case 5:
            res_user = _context2.sent;
            _context2.next = 8;
            return res_user.json();

          case 8:
            jsonResult = _context2.sent;
            err = jsonResult.err, _jsonResult$result = jsonResult.result, result = _jsonResult$result === void 0 ? {} : _jsonResult$result;

            if (!err) {
              _context2.next = 15;
              break;
            }

            if (process.env.NODE_ENV === 'development') {
              console.error(jsonResult);
            }

            return _context2.abrupt("return", {
              __gankaoUID: 0,
              __userInfo: null,
              __userInfo_error: err
            });

          case 15:
            if (!result.failMessage) {
              _context2.next = 20;
              break;
            }

            if (process.env.NODE_ENV === 'development') {
              console.error(jsonResult);
            }

            return _context2.abrupt("return", {
              __gankaoUID: 0,
              __userInfo: null,
              __userInfo_error: result.failMessage
            });

          case 20:
            _ref4 = result || {}, gankaoUID = _ref4.gankaoUID, gankaoUserInfo = _ref4.gankaoUserInfo;
            return _context2.abrupt("return", {
              __gankaoUID: gankaoUID,
              __userInfo: gankaoUserInfo,
              __userInfo_error: null
            });

          case 22:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getUserInfo(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var BindGkInfoAndInjectToReqMiddleWare = function BindGkInfoAndInjectToReqMiddleWare(_ref5) {
  var _ref5$debug = _ref5.debug,
      debug = _ref5$debug === void 0 ? false : _ref5$debug,
      GKP_or_GKAPI = _ref5.GKP_or_GKAPI,
      expressObj = _ref5.expressObj,
      parseServiceEndPoint = _ref5.parseServiceEndPoint,
      shouldBind = _ref5.shouldBind;
  if (typeof GKP_or_GKAPI !== "function") throw new Error('parseGkInfoAndInjectToReqMiddleWare的GKP_or_GKAPI参数不是有效的函数！');
  if (!expressObj) throw new Error('parseGkInfoAndInjectToReqMiddleWare的expressObj参数未传入！');

  if (expressObj.injected === true) {
    throw new Error('BindGkInfoAndInjectToReqMiddleWare 不能与injectPartnerInfoToReq同时启用，只能二选一，推荐BindGkInfoAndInjectToReqMiddleWare！');
  }

  if (expressObj.__parsed) return; //TODO:这里需要做互斥，不能和injectPartnerInfoToReq同时启用

  expressObj.__parsed = true; //这里的process.env.PRODUCTION_TYPE会在babel编译期被替换为实际值

  var env = process.env.PRODUCTION_TYPE || 'development';
  var default_domain = process.env.DEFAULT_DOMAIN || (env === 'production' ? "gankao.com" : "gankaotest2.com");

  if (!parseServiceEndPoint) {
    _parseServiceEndPoint = "https://api.".concat(default_domain, "/api-account");
  } else {
    _parseServiceEndPoint = parseServiceEndPoint;
  }

  console.log("\nBindGkInfoAndInjectToReqMiddleWare:\u6CE8\u5165[\u68C0\u6D4B\u5F53\u524D\u7528\u6237/\u673A\u6784]\u7684\u4E2D\u95F4\u4EF6\uFF0C\u5C06\u4E24\u8005\u4FE1\u606F\u52A8\u6001\u7ED1\u5B9A\u5230req\u5BF9\u8C61\u4E0A\uFF0C\u63D0\u4F9B\u4EE5\u4E0B\u4FE1\u606F\uFF1A\n    req.__partner //\u5F53\u524D\u673A\u6784\u4FE1\u606F\n    req.__partner_error //\u5F53\u524D\u673A\u6784\u4FE1\u606F\n    req.__gankaoUID     //\u5F53\u524D\u767B\u5F55\u7528\u6237UID\uFF0C\u672A\u767B\u5F55\u65F6\u4E3A0\n    req.__userInfo,     //\u5F53\u524D\u767B\u5F55\u7528\u6237\uFF0C\u672A\u767B\u5F55\u65F6\u4E3Anull\n    /p-**/_current      //\u83B7\u5F97\u5F53\u524D\u4FE1\u606F\u7684\u8DEF\u7531\uFF0C\u8FD4\u56DE\u7ED3\u6784\uFF1A{__partner, __partner_error, __gankaoUID, __userInfo}\n    /api-**/_current      //\u540C\u4E0A\uFF0CAPI\u7528\n    /p-**/_hello        //\u5B58\u6D3B\u63A2\u9488\u68C0\u6D4B\uFF0C\u8FD4\u56DE\u4E00\u4E2A\u6D4B\u8BD5\u7528json\uFF0C\u5982:{ok: 'hello! pass ?test=1 for await 300ms'}\n    /api-**/_hello        //\u540C\u4E0A\uFF0CAPI\u7528\n    \n    \u6570\u636E\u670D\u52A1\u63D0\u4F9B\u65B9\uFF1A".concat(_parseServiceEndPoint, "\n    "));
  console.log("expressObj.__parsed:", expressObj.__parsed);
  expressObj.use(
  /*#__PURE__*/
  function () {
    var _ref6 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(req, res, next) {
      var hostname, AuthorizationOrToken, _ref7, _ref8, r1, r2, __partner, __partner_error, _r2$__gankaoUID, __gankaoUID, __userInfo, __userInfo_error;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!((req.path || "").indexOf("/_next/") > -1 || (req.path || "").indexOf("favicon.ico") > -1)) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return", next());

            case 2:
              if (!(typeof shouldBind === "function")) {
                _context3.next = 5;
                break;
              }

              if (shouldBind(req, res)) {
                _context3.next = 5;
                break;
              }

              return _context3.abrupt("return", next());

            case 5:
              hostname = req.headers["host"]; //TODO:这里后续需要做缓存优化，但是缓存的key如何组建？

              AuthorizationOrToken = req.header('Authorization') || req.header('authorization') || req.query.authorization || req.query.Authorization || req.cookies.gkAuthorization || req.cookies.student || '';
              _context3.next = 9;
              return _bluebird["default"].all([getPartner(hostname), getUserInfo(AuthorizationOrToken)]);

            case 9:
              _ref7 = _context3.sent;
              _ref8 = _slicedToArray(_ref7, 2);
              r1 = _ref8[0];
              r2 = _ref8[1];
              __partner = r1.__partner, __partner_error = r1.__partner_error;
              _r2$__gankaoUID = r2.__gankaoUID, __gankaoUID = _r2$__gankaoUID === void 0 ? 0 : _r2$__gankaoUID, __userInfo = r2.__userInfo, __userInfo_error = r2.__userInfo_error; //

              req.__partner = __partner;
              req.__partner_error = __partner_error;
              req.__userInfo = __userInfo;
              req.__userInfo_error = __userInfo_error;
              req.__gankaoUID = __gankaoUID;
              next();

            case 21:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x3, _x4, _x5) {
      return _ref6.apply(this, arguments);
    };
  }());
  /**
   * 当前访问者的用户与机构信息
   */

  expressObj.use(GKP_or_GKAPI(_templateObject || (_templateObject = _taggedTemplateLiteral(["/_current"]))),
  /*#__PURE__*/
  function () {
    var _ref9 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(req, res, next) {
      var __partner, __partner_error, __gankaoUID, __userInfo, __userInfo_error;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              __partner = req.__partner, __partner_error = req.__partner_error, __gankaoUID = req.__gankaoUID, __userInfo = req.__userInfo, __userInfo_error = req.__userInfo_error;
              res.json({
                __partner: __partner,
                __partner_error: __partner_error,
                __gankaoUID: __gankaoUID,
                __userInfo: __userInfo,
                __userInfo_error: __userInfo_error
              });

            case 2:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x6, _x7, _x8) {
      return _ref9.apply(this, arguments);
    };
  }());
  /**
   * 存活行探针，内有300毫秒的等待，配合压力测试
   */

  expressObj.use(GKP_or_GKAPI(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["/_hello"]))),
  /*#__PURE__*/
  function () {
    var _ref10 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5(req, res, next) {
      var _req$query$test, test;

      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _req$query$test = req.query.test, test = _req$query$test === void 0 ? 0 : _req$query$test;

              if (!(~~test === 1)) {
                _context5.next = 4;
                break;
              }

              _context5.next = 4;
              return sleep(300);

            case 4:
              res.json({
                ok: "hello! pass ?test=1 for await 300ms"
              });

            case 5:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function (_x9, _x10, _x11) {
      return _ref10.apply(this, arguments);
    };
  }());
};

exports.BindGkInfoAndInjectToReqMiddleWare = BindGkInfoAndInjectToReqMiddleWare;