"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.varifyParamsWithMD5 = exports.sleep = exports.signParamsWithMD5 = exports.queryToObject = exports.parallelInvokeWithPromise = exports.objectToQuery = exports.load_package_name = exports.hashcode = exports.getSignParamsInMD5 = exports.getCookieDomain2 = exports.getClientIp = exports.delayRun = exports.crash = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _md = _interopRequireDefault(require("md5"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _path = _interopRequireDefault(require("path"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var queryToObject =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(keyStr) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", (0, _lodash.reduce)((keyStr || '').toString().split('&').map(function (item) {
              var _item$split = item.split("="),
                  _item$split2 = _slicedToArray(_item$split, 2),
                  _item$split2$ = _item$split2[0],
                  key = _item$split2$ === void 0 ? '' : _item$split2$,
                  value = _item$split2[1];

              return key && value ? _defineProperty({}, key.toString(), decodeURIComponent(value)) : {};
            }), function (item, current) {
              return _objectSpread2(_objectSpread2({}, current), item);
            }, {}));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function queryToObject(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.queryToObject = queryToObject;

var objectToQuery =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(obj) {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", (0, _lodash.keys)(obj).map(function (key) {
              return "".concat(key, "=").concat(encodeURIComponent(obj[key]));
            }).join("&"));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function objectToQuery(_x2) {
    return _ref3.apply(this, arguments);
  };
}();
/**
 * 获得对象的MD5签名，按排序的key-value拼接字符串计算，value中的对象做JSON.stringify处理
 * @param param
 * @param secret
 * @param whiteProps
 * @param onlyAppendKeyValue
 * @returns {string}
 */


exports.objectToQuery = objectToQuery;

var getSignParamsInMD5 = function getSignParamsInMD5(_ref4) {
  var _ref4$param = _ref4.param,
      param = _ref4$param === void 0 ? {} : _ref4$param,
      _ref4$secret = _ref4.secret,
      secret = _ref4$secret === void 0 ? '' : _ref4$secret,
      _ref4$whiteProps = _ref4.whiteProps,
      whiteProps = _ref4$whiteProps === void 0 ? [] : _ref4$whiteProps,
      _ref4$onlyAppendKeyVa = _ref4.onlyAppendKeyValue,
      onlyAppendKeyValue = _ref4$onlyAppendKeyVa === void 0 ? false : _ref4$onlyAppendKeyVa;
  var whiteList = ['pfx', 'partner_key', '_sign', 'sign', 'key'].concat(_toConsumableArray(whiteProps));
  var querystring = Object.keys(param).filter(function (key) {
    return param[key] !== undefined && param[key] !== '' && whiteList.indexOf(key) < 0;
  }).sort().map(function (key) {
    return key + '=' + JSON.stringify(param[key]);
  }).join("&") + (onlyAppendKeyValue ? "&key=" : '') + secret;
  return (0, _md["default"])(querystring).toUpperCase();
};
/**
 * 早期API，请换用getSignParamsInMD5来调用
 * 对参数对象进行签名，签名结果以_sign结果混合在params中输出
 * @param param
 * @param secret
 * @returns {{_sign: string}}
 */


exports.getSignParamsInMD5 = getSignParamsInMD5;

var signParamsWithMD5 = function signParamsWithMD5(_ref5) {
  var param = _ref5.param,
      secret = _ref5.secret;

  var _sign = getSignParamsInMD5({
    param: param,
    secret: secret
  });

  return _objectSpread2(_objectSpread2({}, param || {}), {}, {
    _sign: _sign
  });
};
/**
 * 对收到的参数对象进行md5签名验证，参数中需要求包含_sign属性
 * @param paramsSigned
 * @param secret
 * @returns {{err: null, success: boolean}|{err: string, success: boolean}}
 */


exports.signParamsWithMD5 = signParamsWithMD5;

var varifyParamsWithMD5 = function varifyParamsWithMD5(_ref6) {
  var paramSigned = _ref6.paramSigned,
      secret = _ref6.secret;
  if (!paramSigned._sign) return {
    success: false,
    err: 'NO_SIGN'
  };
  if (!secret) return {
    success: false,
    err: 'NO_SECRET'
  };

  var _signAgian = getSignParamsInMD5({
    param: paramSigned,
    secret: secret
  });

  if (_signAgian !== paramSigned._sign) return {
    success: false,
    err: 'SIGN_WRONG',
    _needSign: paramSigned._sign,
    _reSign: _signAgian
  };
  return {
    success: true,
    err: null
  };
};
/**
 * 从express的request中获取请求方的IP地址
 * @param req
 * @returns {*}
 */


exports.varifyParamsWithMD5 = varifyParamsWithMD5;

var getClientIp = function getClientIp(req) {
  try {
    return req.headers['x-real-ip'] || req.headers['x-forwarded-for'] || req.connection.remoteAddress || req.socket.remoteAddress || req.connection.socket.remoteAddress;
  } catch (err) {
    return "-not-get-ip";
  }
};
/**
 * 等待指定毫秒时间后再继续执行
 * @param ms
 * @returns {Promise}
 */


exports.getClientIp = getClientIp;

var sleep = function sleep(ms) {
  return new _bluebird["default"](function (resolve, reject) {
    setTimeout(function (_) {
      return resolve(ms);
    }, ms);
  });
};
/**
 * 主动制造一个奔溃，让程序马上停止下来，内部时setTime机制，所以不受外围的try-catch的限制
 * @param title
 */


exports.sleep = sleep;

var crash = function crash(title) {
  setTimeout(function () {
    throw new Error(title || '主动crash');
  }, 20);
};
/**
 * 延迟指定时间执行函数，并捕获错误
 * @param fun
 * @param ms
 * @param errerhandle
 */


exports.crash = crash;

var delayRun = function delayRun(fun, ms, errerhandle) {
  setTimeout(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3() {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            _context3.next = 3;
            return fun();

          case 3:
            _context3.next = 8;
            break;

          case 5:
            _context3.prev = 5;
            _context3.t0 = _context3["catch"](0);
            if (errerhandle) errerhandle(_context3.t0);else {
              console.error("error in delayRun:");
              console.error(_context3.t0);
            }

          case 8:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[0, 5]]);
  })), ms || 0);
};
/**
 * 获取给定字符串的hashcode值
 * @param str
 * @returns {number}
 */


exports.delayRun = delayRun;

var hashcode = function hashcode(str) {
  var hash = 0,
      i,
      chr,
      len;
  if (str.length === 0) return hash;

  for (i = 0, len = str.length; i < len; i++) {
    chr = str.charCodeAt(i);
    hash = (hash << 5) - hash + chr;
    hash |= 0; // Convert to 32bit integer
  }

  return hash;
};
/*
获取package中的系统名
*/


exports.hashcode = hashcode;

var load_package_name = function load_package_name() {
  var _require = require(_path["default"].join(process.cwd(), 'package.json')),
      _require$name = _require.name,
      name = _require$name === void 0 ? '' : _require$name;

  var applicationName = name.split(".")[0];
  if (!applicationName) throw new Error("\u4E1A\u52A1\u7CFB\u7EDF\u540D\u83B7\u53D6\u5931\u8D25\uFF0C\u6743\u9650\u7BA1\u7406\u8BA4\u8BC1\u5C06\u5931\u6548\uFF0C\u8BF7\u786E\u8BA4\u5B58\u5728package.json\u4E14\u5176\u4E2D\u5DF2\u914D\u7F6Ename\u5C5E\u6027");
  return applicationName;
}; // let res_promise = parallelCallWithPromise({url:'.....'});
// let value = await result;


exports.load_package_name = load_package_name;

var parallelInvokeWithPromise = function parallelInvokeWithPromise(_ref8) {
  var url = _ref8.url,
      _ref8$params = _ref8.params,
      params = _ref8$params === void 0 ? {} : _ref8$params,
      _ref8$timeout = _ref8.timeout,
      timeout = _ref8$timeout === void 0 ? 3000 : _ref8$timeout;
  return new _bluebird["default"](
  /*#__PURE__*/
  function () {
    var _ref9 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(resolve, reject) {
      var options, res, body, err, result;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              options = {
                method: "post",
                rejectUnauthorized: false,
                headers: {
                  'Accept': 'application/json, text/plain, */*',
                  'Content-Type': 'application/json'
                },
                json: true,
                body: JSON.stringify(params),
                timeout: timeout
              };
              _context4.next = 4;
              return (0, _nodeFetch["default"])(url, options);

            case 4:
              res = _context4.sent;
              _context4.next = 7;
              return res.json();

            case 7:
              body = _context4.sent;
              err = body.err, result = body.result;

              if (err) {
                reject({
                  err: err.message,
                  result: null
                });
              } else {
                resolve({
                  err: null,
                  result: result
                });
              }

              _context4.next = 16;
              break;

            case 12:
              _context4.prev = 12;
              _context4.t0 = _context4["catch"](0);
              console.error(_context4.t0.stack);
              reject({
                err: _context4.t0.message,
                result: null
              });

            case 16:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[0, 12]]);
    }));

    return function (_x3, _x4) {
      return _ref9.apply(this, arguments);
    };
  }());
};

exports.parallelInvokeWithPromise = parallelInvokeWithPromise;

var getCookieDomain2 = function getCookieDomain2(reqOrHostName) {
  var hostname = '';

  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object") {
    hostname = window.location.hostname;
  } else {
    if (!reqOrHostName) {
      throw new Error('_getCookieDomain2函数在服务器端运行时，需传入req或hostname值的参数');
    }

    hostname = _typeof(reqOrHostName) === "object" ? reqOrHostName.headers["host"] : reqOrHostName;
  }

  var _hostname$split$0$spl = hostname.split(":")[0].split(".").reverse(),
      _hostname$split$0$spl2 = _slicedToArray(_hostname$split$0$spl, 2),
      domainType = _hostname$split$0$spl2[0],
      _hostname$split$0$spl3 = _hostname$split$0$spl2[1],
      domain = _hostname$split$0$spl3 === void 0 ? '' : _hostname$split$0$spl3;

  return "".concat(domain, ".").concat(domainType);
};

exports.getCookieDomain2 = getCookieDomain2;