"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doSendVlog = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _superagent = _interopRequireDefault(require("superagent"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _lodash = require("lodash");

var _util = require("../class2api/util");

var _excluded = ["_debugTrace", "_apiUrl", "_secret", "_resendTimes"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_bluebird["default"].promisifyAll(_superagent["default"]);

var filelist = []; //每间隔1秒重新发送队列，队列中的数据被处理3次后依然未成功发送出去的，暂时被被丢弃

var _timer = setInterval(
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
_regenerator["default"].mark(function _callee() {
  var needResends, i, item;
  return _regenerator["default"].wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (filelist.length > 0) {
            if (filelist[0]._debugTrace) {
              //统计超过3次重发的量，给予控制台输出提示
              needResends = (0, _lodash.filter)(filelist, function (item) {
                return item._resendTimes < 3;
              });

              if (filelist.length > needResends.length) {
                console.error("TransferVLog \u5185\u90E8\u91CD\u53D1\u6B21\u6570\u8D85\u8FC73\u6B21\u7684\u65E5\u5FD7\uFF0C\u88AB\u4E22\u5F03 ".concat(filelist.length - needResends.length, " \u4E2A."));
              }
            }

            for (i = 0; i < Math.min(20, filelist.length); i++) {
              item = filelist.shift();

              if (item) {
                if (item._resendTimes < 3) {
                  //doSend内部如果发送失败，则会自动又加入filelist队列
                  doSend(item).then(); //这里其实是异步发送，for会一下子执行完
                } else {//超过3次的，不做发送，也就没机会再进入队列，直接被丢弃了
                  }
              }
            }
          }

        case 1:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})), 1000);

var doSend =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3(data) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            setImmediate(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            _regenerator["default"].mark(function _callee2() {
              var _ref4, _debugTrace, _apiUrl, _secret, _ref4$_resendTimes, _resendTimes, postData;

              return _regenerator["default"].wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      if (!(_typeof(data) !== "object")) {
                        _context2.next = 3;
                        break;
                      }

                      console.error("TransferVLog\u4E2D\u9519\u8BEF1\uFF1A\u4F20\u5165\u7684\u65E5\u5FD7\u8BB0\u5F55\u4FE1\u606F\u4E0D\u662F\u6709\u6548\u7684Object\u7C7B\u578B");
                      return _context2.abrupt("return");

                    case 3:
                      _ref4 = data || {}, _debugTrace = _ref4._debugTrace, _apiUrl = _ref4._apiUrl, _secret = _ref4._secret, _ref4$_resendTimes = _ref4._resendTimes, _resendTimes = _ref4$_resendTimes === void 0 ? 0 : _ref4$_resendTimes, postData = _objectWithoutProperties(_ref4, _excluded);

                      try {
                        if (!postData.sign) {
                          postData.sign = (0, _util.getSignParamsInMD5)({
                            param: postData,
                            secret: _secret
                          });
                        } //发送流水


                        _superagent["default"].post(_apiUrl).withCredentials().set('Accept', 'application/json, text/plain, */*').set('Content-Type', 'application/json').send({
                          postData: postData
                        }).retry(2) //superagent内部先发送两次
                        .then(function (res) {
                          if (res.status === 200) {
                            if (_debugTrace) {
                              try {
                                var _res$body = res.body,
                                    err = _res$body.err,
                                    result = _res$body.result;

                                if (err) {
                                  console.error("========Vlog res business error  ... ".concat(err, "..!"));
                                  console.error(JSON.stringify({
                                    err: err,
                                    result: result
                                  }));
                                } else {
                                  console.log('========Vlog send ok!');
                                }
                              } catch (err) {
                                console.error("========Vlog res parse error  ... ".concat(err, "..!"));
                                console.error(res.body);
                              }
                            }
                          } else {
                            //注意加入list的是data，而不是postData
                            console.error("========Vlog res net error  ... ".concat(res.status, "..!") + postData);
                            data._resendTimes++;
                            filelist.push(data);
                          }
                        }, function (err) {
                          if (_debugTrace) {
                            console.error("========Vlog res error  ... ".concat(err, "..!") + postData);
                            console.error(ex.stack);
                          } //注意加入list的是data，而不是postData


                          data._resendTimes++;
                          filelist.push(data);
                        });
                      } catch (ex) {
                        if (_debugTrace) {
                          console.error("TransferVLog\u4E2D\u9519\u8BEF\uFF1A");
                          console.error(ex.stack);
                        } //注意加入list的是data，而不是postData


                        data._resendTimes++;
                        filelist.push(data);
                      }

                    case 5:
                    case "end":
                      return _context2.stop();
                  }
                }
              }, _callee2);
            })));

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function doSend(_x) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * 发送泛业务日志
 * @param isProduction  是否为生产环境
 * @param sysName
 * @param sourceHeaders
 * @param userID
 * @param action
 * @param targetType
 * @param time
 * @param targetID
 * @param targetOwnerUID
 * @param comment
 * @param _resendTimes
 * @returns {Promise<void>}
 */


process.on('message', function (data) {
  doSend(data).then();
});
var doSendVlog = doSend;
exports.doSendVlog = doSendVlog;